polybori::PBoRiOutIter< DataType, RhsType, BinOp > Class Template Reference

This template class defines an output iterator which interprets assignments of indices as a change of given data wrt. a given binary operation. More...

`#include <PBoRiOutIter.h>`

## Public Types

typedef DataType | data_type
| Data type. More...
typedef RhsType | rhs_type
| Type of right-hand side. More...
typedef BinOp | op_type
| Type of binary operation used to transform data and rhs. More...
typedef PBoRiOutIter < data_type, rhs_type, op_type > | self
| Type of *this. More...
Interface types for standard iterator access
typedef std::output_iterator_tag | iterator_category
typedef void | difference_type
typedef void | pointer
typedef void | reference
typedef void | value_type

## Public Member Functions

| PBoRiOutIter (data_type &data_, op_type op_=op_type())
| Constructor. More...
| PBoRiOutIter (const self &rhs)
| Copy constructor. More...
| ~PBoRiOutIter ()
| Destructor. More...
self & | operator* ()
self & | operator= (const self &rhs)
| Assignment. More...
self & | operator= (rhs_type rhs)
| Assignment of index calls for change of that index in the monomial. More...
self & | operator++ ()
| Prefix increment operator. More...
self | operator++ (int)
| Postfix increment operator. More...

## Protected Attributes

data_type & | data
op_type | op

## Detailed Description

### template<class DataType, class RhsType, class BinOp>
class polybori::PBoRiOutIter< DataType, RhsType, BinOp >

This template class defines an output iterator which interprets assignments of indices as a change of given data wrt. a given binary operation.

## Member Typedef Documentation

template<class DataType, class RhsType, class BinOp>

typedef DataType polybori::PBoRiOutIter< DataType, RhsType, BinOp >::data_type

Data type.

template<class DataType, class RhsType, class BinOp>

typedef void polybori::PBoRiOutIter< DataType, RhsType, BinOp >::difference_type

template<class DataType, class RhsType, class BinOp>

typedef std::output_iterator_tag polybori::PBoRiOutIter< DataType, RhsType, BinOp >::iterator_category

template<class DataType, class RhsType, class BinOp>

typedef BinOp polybori::PBoRiOutIter< DataType, RhsType, BinOp >::op_type

Type of binary operation used to transform data and rhs.

template<class DataType, class RhsType, class BinOp>

typedef void polybori::PBoRiOutIter< DataType, RhsType, BinOp >::pointer

template<class DataType, class RhsType, class BinOp>

typedef void polybori::PBoRiOutIter< DataType, RhsType, BinOp >::reference

template<class DataType, class RhsType, class BinOp>

typedef RhsType polybori::PBoRiOutIter< DataType, RhsType, BinOp >::rhs_type

Type of right-hand side.

template<class DataType, class RhsType, class BinOp>

typedef PBoRiOutIter<data_type, rhs_type, op_type> polybori::PBoRiOutIter< DataType, RhsType, BinOp >::self

Type of *this.

template<class DataType, class RhsType, class BinOp>

typedef void polybori::PBoRiOutIter< DataType, RhsType, BinOp >::value_type

## Constructor & Destructor Documentation

template<class DataType, class RhsType, class BinOp>

polybori::PBoRiOutIter< DataType, RhsType, BinOp >::PBoRiOutIter | ( | data_type & | data_,
|  | op_type | op_ = `op_type()`
| ) |  |

inline

Constructor.

template<class DataType, class RhsType, class BinOp>

polybori::PBoRiOutIter< DataType, RhsType, BinOp >::PBoRiOutIter | ( | const self & | rhs) |  |

inline

Copy constructor.

template<class DataType, class RhsType, class BinOp>

polybori::PBoRiOutIter< DataType, RhsType, BinOp >::~PBoRiOutIter | ( | ) |  |

inline

Destructor.

## Member Function Documentation

template<class DataType, class RhsType, class BinOp>

self& polybori::PBoRiOutIter< DataType, RhsType, BinOp >::operator* | ( | ) |  |

inline

Dereference operator

Note
  *this is used as proxy reference

template<class DataType, class RhsType, class BinOp>

self& polybori::PBoRiOutIter< DataType, RhsType, BinOp >::operator++ | ( | ) |  |

inline

Prefix increment operator.

template<class DataType, class RhsType, class BinOp>

self polybori::PBoRiOutIter< DataType, RhsType, BinOp >::operator++ | ( | int | ) |  |

inline

Postfix increment operator.

template<class DataType, class RhsType, class BinOp>

self& polybori::PBoRiOutIter< DataType, RhsType, BinOp >::operator= | ( | const self & | rhs) |  |

inline

Assignment.

References polybori::PBoRiOutIter< DataType, RhsType, BinOp >::data.

template<class DataType, class RhsType, class BinOp>

self& polybori::PBoRiOutIter< DataType, RhsType, BinOp >::operator= | ( | rhs_type | rhs) |  |

inline

Assignment of index calls for change of that index in the monomial.

## Member Data Documentation

template<class DataType, class RhsType, class BinOp>

data_type& polybori::PBoRiOutIter< DataType, RhsType, BinOp >::data

protected

Referenced by polybori::PBoRiOutIter< DataType, RhsType, BinOp >::operator=().

template<class DataType, class RhsType, class BinOp>

op_type polybori::PBoRiOutIter< DataType, RhsType, BinOp >::op

protected

The documentation for this class was generated from the following file:

- PBoRiOutIter.h